"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var crypto_1 = require("crypto");
var lifecycle_1 = require("../shared/lifecycle");
function hash(x) {
    return crypto_1.createHash('md5').update(x).digest('base64').toString();
}
function createInfo(name, trace) {
    var filename = trace.getFileName() || '';
    return { name: name, filename: filename, hash: hash(filename + '::' + name), resolved: false };
}
exports.createInfo = createInfo;
function attachInfo(node, info) {
    if (node instanceof DocumentFragment)
        attachInfo(lifecycle_1.getLSMarker(node), info);
    else
        node.__transport_info = info;
}
exports.attachInfo = attachInfo;
function fetchInfo(node) {
    if (node instanceof DocumentFragment)
        return fetchInfo(lifecycle_1.getLSMarker(node));
    else {
        var res_1 = [];
        var info = node.__transport_info;
        if (info)
            res_1.push(info);
        node.childNodes.forEach(function (child) { return res_1 = res_1.concat(fetchInfo(child)); });
        return res_1;
    }
}
exports.fetchInfo = fetchInfo;
//# sourceMappingURL=transport-info.js.map