"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var CompContextSubjectPlugin = /** @class */ (function () {
    function CompContextSubjectPlugin() {
        this.priority = html_1.PluginPriority.High;
    }
    CompContextSubjectPlugin.prototype.wireContext = function (_, value, recipient, __) {
        if (recipient instanceof rxjs_1.Subject) {
            if (core_1.isPinLike(value))
                value.subscribe(recipient);
            else if (value instanceof rxjs_1.Observable)
                value.subscribe(recipient);
            else if (value instanceof Promise)
                rxjs_1.from(value).subscribe(recipient);
            else
                rxjs_1.of(value).subscribe(recipient);
            return true;
        }
        return false;
    };
    return CompContextSubjectPlugin;
}());
exports.CompContextSubjectPlugin = CompContextSubjectPlugin;
//# sourceMappingURL=comp-context-subject.js.map