"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var CompInputSubjectPlugin = /** @class */ (function () {
    function CompInputSubjectPlugin() {
        this.priority = html_1.PluginPriority.High;
    }
    CompInputSubjectPlugin.prototype.wireProp = function (name, prop, host, signature) {
        if (signature.inputs && name in signature.inputs && signature.inputs[name] instanceof rxjs_1.Subject) {
            var input_1 = signature.inputs[name];
            if (prop instanceof rxjs_1.Observable)
                lifecycle_1.whenRendered(host, function () { return prop.subscribe(input_1); });
            else if (core_1.isPinLike(prop))
                lifecycle_1.whenRendered(host, function () { return prop.subscribe(input_1); });
            else if (prop instanceof Promise)
                lifecycle_1.whenRendered(host, function () { return rxjs_1.from(prop).subscribe(input_1); });
            else
                lifecycle_1.whenRendered(host, function () { return rxjs_1.of(prop).subscribe(input_1); });
            return true;
        }
        return false;
    };
    return CompInputSubjectPlugin;
}());
exports.CompInputSubjectPlugin = CompInputSubjectPlugin;
//# sourceMappingURL=comp-input-subject.js.map