"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var ObservableClassPlugin = /** @class */ (function () {
    function ObservableClassPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    ObservableClassPlugin.prototype.setprop = function (prop, target, host) {
        if (prop === 'class' && target instanceof rxjs_1.Observable) {
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.toPromise().then(function (v) {
                    var classes = (v !== undefined) ? v.toString() : '';
                    var fixed = html_1.ClassListFixed.get(host);
                    if (fixed.length > 0)
                        classes += ' ' + fixed.join(' ');
                    host.setAttribute('class', classes);
                }));
            });
            return true;
        }
        return false;
    };
    return ObservableClassPlugin;
}());
exports.ObservableClassPlugin = ObservableClassPlugin;
//# sourceMappingURL=observable-class.js.map