"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var ObservableInnerHTMLPlugin = /** @class */ (function () {
    function ObservableInnerHTMLPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    ObservableInnerHTMLPlugin.prototype.setprop = function (prop, target, host) {
        if (prop === '_innerHTML' && target instanceof rxjs_1.Observable) {
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.toPromise().then(function (v) {
                    host.innerHTML = (v !== undefined) ? v.toString() : '';
                }));
            });
            return true;
        }
        return false;
    };
    return ObservableInnerHTMLPlugin;
}());
exports.ObservableInnerHTMLPlugin = ObservableInnerHTMLPlugin;
//# sourceMappingURL=observable-inner-html.js.map