"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var ObservablePlugin = /** @class */ (function () {
    function ObservablePlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    ObservablePlugin.prototype.setprop = function (prop, target, host) {
        if (target instanceof rxjs_1.Observable) {
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.toPromise().then(function (v) {
                    if (typeof v === 'boolean') {
                        if (v)
                            host.setAttribute(prop, '');
                        else
                            host.removeAttribute(prop);
                    }
                    else
                        host.setAttribute(prop, (v !== undefined) ? v.toString() : '');
                }));
            });
            return true;
        }
        return false;
    };
    ObservablePlugin.prototype.append = function (target, host) {
        if (target instanceof rxjs_1.Observable) {
            var _target_1 = document.createTextNode('');
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.toPromise().then(function (v) {
                    _target_1.textContent = (v !== undefined) ? v.toString() : '';
                }));
            });
            host.appendChild(_target_1);
            return true;
        }
        return false;
    };
    return ObservablePlugin;
}());
exports.ObservablePlugin = ObservablePlugin;
//# sourceMappingURL=observable.js.map