"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var CompInputPinPlugin = /** @class */ (function () {
    function CompInputPinPlugin() {
        this.priority = html_1.PluginPriority.High;
    }
    CompInputPinPlugin.prototype.wireProp = function (name, prop, _, signature) {
        if (signature.inputs && name in signature.inputs && core_1.isPinLike(signature.inputs[name])) {
            var input = signature.inputs[name];
            if (prop instanceof rxjs_1.Observable)
                core_1.wrap(prop).to(input);
            else if (core_1.isPinLike(prop))
                prop.to(input);
            else if (prop instanceof Promise)
                core_1.wrap(rxjs_1.from(prop)).to(input);
            else
                core_1.value(prop).to(input);
            return true;
        }
        return false;
    };
    return CompInputPinPlugin;
}());
exports.CompInputPinPlugin = CompInputPinPlugin;
//# sourceMappingURL=comp-input-pin.js.map