"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var PinClassPlugin = /** @class */ (function () {
    function PinClassPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    PinClassPlugin.prototype.setprop = function (prop, target, host) {
        if (prop === 'class' && core_1.isPinLike(target)) {
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.observable.toPromise().then(function (v) {
                    var classes = (v.value !== undefined) ? v.value.toString() : '';
                    var fixed = html_1.ClassListFixed.get(host);
                    if (fixed.length > 0)
                        classes += ' ' + fixed.join(' ');
                    host.setAttribute('class', classes);
                }));
            });
            return true;
        }
        return false;
    };
    return PinClassPlugin;
}());
exports.PinClassPlugin = PinClassPlugin;
//# sourceMappingURL=pin-class.js.map