"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var PinInnerHTMLPlugin = /** @class */ (function () {
    function PinInnerHTMLPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    PinInnerHTMLPlugin.prototype.setprop = function (prop, target, host) {
        if (prop === '_innerHTML' && core_1.isPinLike(target)) {
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.observable.toPromise().then(function (v) {
                    host.innerHTML = (v.value !== undefined) ? v.value.toString() : '';
                }));
            });
            return true;
        }
        return false;
    };
    return PinInnerHTMLPlugin;
}());
exports.PinInnerHTMLPlugin = PinInnerHTMLPlugin;
//# sourceMappingURL=pin-inner-html.js.map