"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var PinPlugin = /** @class */ (function () {
    function PinPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    PinPlugin.prototype.setprop = function (prop, target, host) {
        if (core_1.isPinLike(target)) {
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.observable.toPromise().then(function (v) {
                    if (typeof v.value === 'boolean') {
                        if (v.value)
                            host.setAttribute(prop, '');
                        else
                            host.removeAttribute(prop);
                    }
                    else
                        host.setAttribute(prop, (v.value !== undefined) ? v.value.toString() : '');
                }));
            });
            return true;
        }
        return false;
    };
    PinPlugin.prototype.append = function (target, host) {
        if (core_1.isPinLike(target)) {
            var _target_1 = document.createTextNode('');
            lifecycle_1.whenRendered(host, function () {
                lifecycle_1.attachPromise(host, target.observable.toPromise().then(function (v) {
                    _target_1.textContent = (v && v.value !== undefined) ? v.value.toString() : '';
                }));
            });
            host.appendChild(_target_1);
            return true;
        }
        return false;
    };
    return PinPlugin;
}());
exports.PinPlugin = PinPlugin;
//# sourceMappingURL=pin.js.map