"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var recipient_promise_1 = require("./recipient-promise");
var CompContextPromisePlugin = /** @class */ (function () {
    function CompContextPromisePlugin() {
        this.priority = html_1.PluginPriority.High;
    }
    CompContextPromisePlugin.prototype.wireContext = function (_, value, recipient, __) {
        if (recipient_promise_1.isRecipientPromise(recipient)) {
            if (core_1.isPinLike(value))
                value.observable.toPromise().then(function (v) { return recipient.recieve(v.value); });
            else if (value instanceof rxjs_1.Observable)
                value.toPromise().then(function (v) { return recipient.recieve(v); });
            else if (value instanceof Promise)
                value.then(function (v) { return recipient.recieve(v); });
            else
                recipient.recieve(value);
            return true;
        }
        return false;
    };
    return CompContextPromisePlugin;
}());
exports.CompContextPromisePlugin = CompContextPromisePlugin;
//# sourceMappingURL=comp-context-promise.js.map