"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var core_1 = require("@connectv/core");
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var recipient_promise_1 = require("./recipient-promise");
var CompInputPromisePlugin = /** @class */ (function () {
    function CompInputPromisePlugin() {
        this.priority = html_1.PluginPriority.High;
    }
    CompInputPromisePlugin.prototype.wireProp = function (name, prop, host, signature) {
        if (signature.inputs && name in signature.inputs && recipient_promise_1.isRecipientPromise(signature.inputs[name])) {
            var input_1 = signature.inputs[name];
            if (prop instanceof rxjs_1.Observable)
                lifecycle_1.whenRendered(host, function () { return prop.toPromise().then(function (v) { return input_1.recieve(v); }); });
            else if (core_1.isPinLike(prop))
                lifecycle_1.whenRendered(host, function () { return prop.observable.toPromise().then(function (v) { return input_1.recieve(v.value); }); });
            else if (prop instanceof Promise)
                prop.then(function (v) { return input_1.recieve(v); });
            else
                input_1.recieve(prop);
            return true;
        }
        return false;
    };
    return CompInputPromisePlugin;
}());
exports.CompInputPromisePlugin = CompInputPromisePlugin;
//# sourceMappingURL=comp-input-promise.js.map