"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var PromiseClassPlugin = /** @class */ (function () {
    function PromiseClassPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    PromiseClassPlugin.prototype.setprop = function (prop, target, host) {
        if (prop === 'class' && target instanceof Promise) {
            lifecycle_1.attachPromise(host, target.then(function (v) {
                var classes = (v !== undefined) ? v.toString() : '';
                var fixed = html_1.ClassListFixed.get(host);
                if (fixed.length > 0)
                    classes += ' ' + fixed.join(' ');
                host.setAttribute('class', classes);
            }));
            return true;
        }
        return false;
    };
    return PromiseClassPlugin;
}());
exports.PromiseClassPlugin = PromiseClassPlugin;
//# sourceMappingURL=promise-class.js.map