"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var PromiseInnerHTMLPlugin = /** @class */ (function () {
    function PromiseInnerHTMLPlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    PromiseInnerHTMLPlugin.prototype.setprop = function (prop, target, host) {
        if (prop === '_innerHTML' && target instanceof Promise) {
            lifecycle_1.attachPromise(host, target.then(function (v) {
                host.innerHTML = v !== undefined ? v.toString() : '';
            }));
            return true;
        }
        return false;
    };
    return PromiseInnerHTMLPlugin;
}());
exports.PromiseInnerHTMLPlugin = PromiseInnerHTMLPlugin;
//# sourceMappingURL=promise-inner-html.js.map