"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var html_1 = require("@connectv/html");
var lifecycle_1 = require("../../shared/lifecycle");
var PromisePlugin = /** @class */ (function () {
    function PromisePlugin() {
        this.priority = html_1.PluginPriority.Fallback;
    }
    PromisePlugin.prototype.setprop = function (prop, target, host) {
        if (target instanceof Promise) {
            lifecycle_1.attachPromise(host, target.then(function (v) {
                if (typeof v === 'boolean') {
                    if (v)
                        host.setAttribute(prop, '');
                    else
                        host.removeAttribute(prop);
                }
                else
                    host.setAttribute(prop, (v !== undefined) ? v.toString() : '');
            }));
            return true;
        }
        return false;
    };
    PromisePlugin.prototype.append = function (target, host, renderer) {
        if (target instanceof Promise) {
            var marker_1 = renderer.create(html_1.Marker, null);
            host.appendChild(marker_1);
            lifecycle_1.attachPromise(host, target.then(function (v) {
                var _target;
                if (v instanceof Node)
                    _target = v;
                else
                    _target = document.createTextNode((v !== undefined) ? v.toString() : '');
                host.insertBefore(_target, marker_1);
                marker_1.remove();
            }));
            return true;
        }
        return false;
    };
    return PromisePlugin;
}());
exports.PromisePlugin = PromisePlugin;
//# sourceMappingURL=promise.js.map