import { CompType } from '@connectv/html';
import { TransportInfo } from './transport-info';
import { RendererFactory } from './renderer-transport';
export declare enum ProcessingMode {
    ResolveOnly = 0,
    ResolveAndCollect = 1
}
export declare class Bundle {
    readonly url: string;
    imports: TransportInfo[];
    rendererImport: TransportInfo | undefined;
    path: string;
    repack: boolean;
    constructor(url: string, path?: string);
    includes(info: TransportInfo): boolean;
    add(info: TransportInfo): this;
    collect(): (document: HTMLDocument) => void;
    collect(comp: CompType<any, any>, ...rest: CompType<any, any>[]): this;
    resolve(): (document: HTMLDocument) => void;
    process(mode: ProcessingMode): (document: HTMLDocument) => void;
    withRenderer<R, T>(factory: RendererFactory<R, T>): this;
}
