var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { parse, join } from 'path';
import { writeFile, readFile } from 'rxline/fs';
export function metafile(bundle) {
    const { dir, name } = parse(bundle.path);
    return join(dir, name + '.meta.json');
}
export function saveMeta(bundle) {
    return writeFile()({
        path: metafile(bundle),
        root: '',
        content: JSON.stringify(bundle.imports.map(({ hash, name, filename }) => ({ hash, name, filename })), undefined, 2)
    });
}
export function loadMeta(bundle) {
    return __awaiter(this, void 0, void 0, function* () {
        return JSON.parse((yield readFile()({
            path: metafile(bundle),
            root: '',
            content: undefined
        })).content);
    });
}
//# sourceMappingURL=meta.js.map