var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Bundle } from './bundle';
import { pack } from './pack';
import { saveMeta, loadMeta } from './meta';
export function save(bundle) {
    return __awaiter(this, void 0, void 0, function* () {
        yield pack(bundle);
        yield saveMeta(bundle);
    });
}
export function load(path, url) {
    return __awaiter(this, void 0, void 0, function* () {
        const bundle = new Bundle(url || path, path);
        bundle.imports = yield loadMeta(bundle);
        bundle.repack = false;
        return bundle;
    });
}
//# sourceMappingURL=presistence.js.map