var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { autoId } from '@connectv/html';
import { callTrace } from '../shared/trace';
import { recipientPromise } from '../static/promise/recipient-promise';
import { createInfo, attachInfo } from './transport-info';
export function getCompTransportInfo(component) {
    return component.__transport_info;
}
export function attachCompTransportInfo(component, info) {
    component.__transport_info = Object.assign(Object.assign({}, info), { resolved: false });
}
export function transportRef() { return autoId(); }
export function transport(component) {
    const trace = callTrace();
    if (!trace)
        return component; // --> unable to get trace info, perhaps client side code
    const info = createInfo(component.name, trace);
    const comp = function (props, renderer) {
        const id = props._transport || transportRef();
        const script = renderer.create("script", { id: id },
            "(function()",
            '{',
            "window.addEventListener(\"load\", function()",
            '{',
            "if (window.__sdh_transport)",
            '{',
            "window.__sdh_transport(\"",
            id,
            "\", \"",
            info.hash,
            "\", ",
            Promise.all(Object.keys(props).filter(key => key !== '_transport').map((key) => __awaiter(this, void 0, void 0, function* () { return [key, yield this.expose.in(key, recipientPromise())]; })))
                .then(entries => entries.reduce((obj, [key, value]) => {
                obj[key] = value;
                return obj;
            }, {}))
                .then(JSON.stringify),
            ");",
            props._transport ?
                `document.querySelectorAll('[data-transport="${props._transport}"]').forEach(function(node){node.remove()});`
                : '',
            "} }); })()");
        attachInfo(script, info);
        return script;
    };
    attachCompTransportInfo(comp, info);
    return comp;
}
//# sourceMappingURL=transport.js.map