var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { writeFile } from 'rxline/fs';
import { isReady } from '../shared/lifecycle';
export class Compiled {
    constructor(dom, ready) {
        this.dom = dom;
        this.ready = ready;
        this._postProcessors = [];
    }
    isReady() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.ready;
            yield isReady(this.dom.window.document.head);
            yield isReady(this.dom.window.document.body);
            for (let processor of this._postProcessors) {
                yield processor(this.dom.window.document);
            }
            return true;
        });
    }
    serialize() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.isReady();
            return this.dom.serialize();
        });
    }
    save(path, root) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.isReady();
            return writeFile()({ path, root: root || '', content: this.dom.serialize() });
        });
    }
    post(processor) {
        this._postProcessors.push(processor);
        return this;
    }
}
//# sourceMappingURL=compiled.js.map