import { Observable } from 'rxjs';
import { ClassListFixed, PluginPriority } from "@connectv/html";
import { attachPromise, whenRendered } from '../../shared/lifecycle';
export class ObservableClassPlugin {
    constructor() {
        this.priority = PluginPriority.Fallback;
    }
    setprop(prop, target, host) {
        if (prop === 'class' && target instanceof Observable) {
            whenRendered(host, () => {
                attachPromise(host, target.toPromise().then(v => {
                    let classes = (v !== undefined) ? v.toString() : '';
                    const fixed = ClassListFixed.get(host);
                    if (fixed.length > 0)
                        classes += ' ' + fixed.join(' ');
                    host.setAttribute('class', classes);
                }));
            });
            return true;
        }
        return false;
    }
}
//# sourceMappingURL=observable-class.js.map