import { isPinLike } from '@connectv/core';
import { ClassListFixed, PluginPriority } from "@connectv/html";
import { attachPromise, whenRendered } from '../../shared/lifecycle';
export class PinClassPlugin {
    constructor() {
        this.priority = PluginPriority.Fallback;
    }
    setprop(prop, target, host) {
        if (prop === 'class' && isPinLike(target)) {
            whenRendered(host, () => {
                attachPromise(host, target.observable.toPromise().then(v => {
                    let classes = (v.value !== undefined) ? v.value.toString() : '';
                    const fixed = ClassListFixed.get(host);
                    if (fixed.length > 0)
                        classes += ' ' + fixed.join(' ');
                    host.setAttribute('class', classes);
                }));
            });
            return true;
        }
        return false;
    }
}
//# sourceMappingURL=pin-class.js.map