import { isPinLike } from '@connectv/core';
import { PluginPriority } from "@connectv/html";
import { attachPromise, whenRendered } from '../../shared/lifecycle';
export class PinInnerHTMLPlugin {
    constructor() {
        this.priority = PluginPriority.Fallback;
    }
    setprop(prop, target, host) {
        if (prop === '_innerHTML' && isPinLike(target)) {
            whenRendered(host, () => {
                attachPromise(host, target.observable.toPromise().then(v => {
                    host.innerHTML = (v.value !== undefined) ? v.value.toString() : '';
                }));
            });
            return true;
        }
        return false;
    }
}
//# sourceMappingURL=pin-inner-html.js.map