import { isPinLike } from '@connectv/core';
import { PluginPriority } from '@connectv/html';
import { attachPromise, whenRendered } from '../../shared/lifecycle';
export class PinPlugin {
    constructor() {
        this.priority = PluginPriority.Fallback;
    }
    setprop(prop, target, host) {
        if (isPinLike(target)) {
            whenRendered(host, () => {
                attachPromise(host, target.observable.toPromise().then(v => {
                    if (typeof v.value === 'boolean') {
                        if (v.value)
                            host.setAttribute(prop, '');
                        else
                            host.removeAttribute(prop);
                    }
                    else
                        host.setAttribute(prop, (v.value !== undefined) ? v.value.toString() : '');
                }));
            });
            return true;
        }
        return false;
    }
    append(target, host) {
        if (isPinLike(target)) {
            let _target = document.createTextNode('');
            whenRendered(host, () => {
                attachPromise(host, target.observable.toPromise().then(v => {
                    _target.textContent = (v && v.value !== undefined) ? v.value.toString() : '';
                }));
            });
            host.appendChild(_target);
            return true;
        }
        return false;
    }
}
//# sourceMappingURL=pin.js.map