import { ClassListFixed, PluginPriority } from '@connectv/html';
import { attachPromise } from "../../shared/lifecycle";
export class PromiseClassPlugin {
    constructor() {
        this.priority = PluginPriority.Fallback;
    }
    setprop(prop, target, host) {
        if (prop === 'class' && target instanceof Promise) {
            attachPromise(host, target.then(v => {
                let classes = (v !== undefined) ? v.toString() : '';
                const fixed = ClassListFixed.get(host);
                if (fixed.length > 0)
                    classes += ' ' + fixed.join(' ');
                host.setAttribute('class', classes);
            }));
            return true;
        }
        return false;
    }
}
//# sourceMappingURL=promise-class.js.map