import { ExtensibleRenderer, Component, RefPlugin, InnerHTMLPlugin, ComponentPlugin, ExposePlugin, CheckCompInputsPlugin } from '@connectv/html';
import { observablePlugins } from './observable';
import { pinPlugins } from './pin';
import { promisePlugins } from './promise';
import { ContextPlugin } from './context';
import { TransportPlugin } from './transport';
export class StaticRenderer extends ExtensibleRenderer {
    constructor() {
        super(new RefPlugin(), new InnerHTMLPlugin(), new ComponentPlugin(), new TransportPlugin(), new ExposePlugin(), new CheckCompInputsPlugin(), new ContextPlugin(), ...observablePlugins(), ...promisePlugins(), ...pinPlugins());
    }
}
export class StaticComponent extends Component {
}
//# sourceMappingURL=renderer.js.map